#ifndef __GF3CALIBRATIONGEOCODINGFUNCUDA__H__
#define __GF3CALIBRATIONGEOCODINGFUNCUDA__H__
#include "gf3calibrationandorthlib_global.h"


#include "BaseConstVariable.h"
#include "GPUTool.cuh"
#include <cuda_runtime.h>
#include <device_launch_parameters.h>
#include <cublas_v2.h>
#include <cuComplex.h>

/** ˺ *********************************************************************************************************************/
/// <summary>
/// 㼫תϵfloat
/// </summary>
/// <param name="inangle"></param>
/// <param name="alpha">ת</param>
/// <returns></returns>
extern __device__ __host__ float Computrer_polartionConver_rpol_f(float inangle, float alpha = 1);

/// <summary>
/// 㼫תϵ (double)
/// </summary>
/// <param name="inangle"></param>
/// <param name="alpha">ת</param>
/// <returns></returns>
extern __device__ __host__ double Computrer_polartionConver_rpol_d(double inangle, double alpha = 1);

/// <summary>
/// ɢϵ任
/// </summary>
/// <param name="insig">sigma0 (dB)</param>
/// <param name="inangle"> ()</param>
/// <param name="alpha">Ĭ1ģͣ0.6Ϊķɭ</param>
/// <param name="isvv">trueʾΪVVfalseΪHH</param>
/// <returns></returns>
extern __host__ __device__ double polartionConver_d(double insig, double inangle, double alpha = 1.0, bool isvv = true);

/// <summary>
/// ɢϵ任
/// </summary>
/// <param name="insig">sigma0 (dB)</param>
/// <param name="inangle"> ()</param>
/// <param name="alpha">Ĭ1ģͣ0.6Ϊķɭ</param>
/// <param name="isvv">trueʾΪVVfalseΪHH</param>
/// <returns></returns>
extern __host__ __device__ float polartionConver_f(float insig, float inangle, float alpha = 1.0, bool isvv = true);






/** ú ******************************************************************************************************************************/

extern "C" void GPUComputePolarizationConver_f(
	float* insig, float* inangle, float* alpha,
	bool isvv, int count,
	float* outsig
);
extern "C" void GPUComputePolarizationConver_d(
	double* insig, double* inangle, double* alpha,
	bool isvv, int count,
	double* outsig
);




#endif

