#include "GF3Util.h"
#include <QString>
#include <QStringList>

GF3TargzFilenameClass  getFilename(QString filename)
{ 
	return GF3TargzFilenameClass(filename);

}

GF3TargzFilenameClass::GF3TargzFilenameClass(QString filename)
{
	// GF3_KAS_FSI_020253_E110.8_N25.5_20200614_L1A_HHHV_L10004871459.tar.gz
	QStringList filelist = filename.split("_");

	this->sateName = filelist[0];
	this->RevStateName = filelist[1];
	this->ImageMode = filelist[2];
	this->OribtName = filelist[3];
	this->CenterLon =  filelist[4].left(1).toDouble();
	this->CenterLat = filelist[5].left(1).toDouble();
 	this->DateName = filelist[6];
	this->levelName = filelist[7];
	this->PolarName = filelist[8];
	this->ProductName = filelist[9];
	if (this->ProductName.contains(".")) {
		this->ProductName = this->ProductName.split(".")[0];
	}else{}
}

GF3TargzFilenameClass::~GF3TargzFilenameClass()
{

}

QString GF3TargzFilenameClass::getSateName() const
{
	return sateName;
}

QString GF3TargzFilenameClass::getRevStateName() const
{
	return RevStateName;
}

QString GF3TargzFilenameClass::getImageMode() const
{
	return ImageMode;
}

QString GF3TargzFilenameClass::getOribtName() const
{
	return OribtName;
}

double GF3TargzFilenameClass::getCenterLon() const
{
	return CenterLon;
}

double GF3TargzFilenameClass::getCenterLat() const
{
	return CenterLat;
}

QString GF3TargzFilenameClass::getDateName() const
{
	return DateName;
}

QString GF3TargzFilenameClass::getLevelName() const
{
	return levelName;
}

QString GF3TargzFilenameClass::getPolarName() const
{
	return PolarName;
}

QString GF3TargzFilenameClass::getProductName() const
{
	return ProductName;
}
