#include "QGF3StripBatchProcessDialog.h"
#include "ui_QGF3StripBatchProcessDialog.h"
#include <QFileDialog>
#include <QApplication>
#include <QMessageBox>
#include "FileOperator.h"
#include "GeoOperator.h"
#include "BaseTool.h"
#include "GF3CalibrationAndGeocodingClass.h"

QGF3StripBatchProcessDialog::QGF3StripBatchProcessDialog(QWidget *parent)
	: QDialog(parent), ui(new Ui::QGF3StripBatchProcessDialogClass)
{
	ui->setupUi(this);

	QObject::connect(ui->pushButtonAdd, SIGNAL(clicked(bool)), this, SLOT(onpushButtonAddClicked(bool)));
	QObject::connect(ui->pushButtonRemove, SIGNAL(clicked(bool)), this, SLOT(onpushButtonRemoveClicked(bool)));
	QObject::connect(ui->pushButtonWorkSpace, SIGNAL(clicked(bool)), this, SLOT(onpushButtonWorkSpaceClicked(bool)));
	QObject::connect(ui->checkBoxDEM, SIGNAL(stateChanged(int)), this, SLOT(ontstateChanged(int)));
	QObject::connect(ui->buttonBox, SIGNAL(rejected()), this, SLOT(onreject()));
	QObject::connect(ui->buttonBox, SIGNAL(accepted()), this, SLOT(onaccept()));
	QObject::connect(ui->pushButton_lineDEM, SIGNAL(clicked(bool)), this, SLOT(onpushButtonDEM(bool)));



}

QGF3StripBatchProcessDialog::~QGF3StripBatchProcessDialog()
{}

void QGF3StripBatchProcessDialog::onaccept()
{
	QString demPath = "";
	// ȡĬDEM
	if (ui->checkBoxDEM->isChecked()) {
		QString demdirPath = QApplication::applicationDirPath();// DEMļ
		demPath = JoinPath(demdirPath,"SRTM_90m_DEM_V4.tif");
	}
	else {
		demPath = ui->lineEdit_DEM->text();
	}
	// ȡֱ
	double resolutionMeter = ui->doubleSpinBox->value();// ֱת
	//double resoiutionDegree = getPixelSpacingInDegree(resolutionMeter);//  -> 
	QString workspacedirpath = ui->lineEditWorkDir->text();
	this->ui->progressBar->setValue(0);
	this->ui->progressBar->setMaximum(ui->listWidgetMetaxml->count());
	bool polarHH2VV = ui->checkoutPolarHH2VV->isChecked();
	for (long i = 0; i < ui->listWidgetMetaxml->count(); i++) {
		QString inTargzFilePath = ui->listWidgetMetaxml->item(i)->text();
		this->ui->label_info->setText(QString(u8"䴦%1").arg(inTargzFilePath));
		GF3MainOrthProcess(demPath,
			inTargzFilePath,
			workspacedirpath,
			resolutionMeter,
			polarHH2VV);

		this->ui->progressBar->setValue(i);
	}
	QMessageBox::information(this, u8"䴦", u8"䴦");
}

void QGF3StripBatchProcessDialog::onreject()
{
	this->close();
}

void QGF3StripBatchProcessDialog::onpushButtonAddClicked(bool)
{
	QStringList fileNames = QFileDialog::getOpenFileNames(
		this,                           // 
		tr(u8"ѡGF3L1Aѹ"),               // 
		QString(),                      // Ĭ·
		tr(u8"tar.gz (*.tar.gz);;tar (*.tar);;All Files (*)")  // ļ
	);

	// ûѡļ
	if (!fileNames.isEmpty()) {
		QString message = "ѡļУ\n";
		for (const QString& fileName : fileNames) {
			this->ui->listWidgetMetaxml->addItem(fileName);
		}
	}
	else {
		QMessageBox::information(this, tr(u8"ûѡļ"), tr(u8"ûѡκļ"));
	}
}

void QGF3StripBatchProcessDialog::onpushButtonRemoveClicked(bool)
{
	QList<QListWidgetItem*> selectedItems = this->ui->listWidgetMetaxml->selectedItems();
	for (QListWidgetItem* item : selectedItems) {
		delete this->ui->listWidgetMetaxml->takeItem(this->ui->listWidgetMetaxml->row(item));
	}
}

void QGF3StripBatchProcessDialog::onpushButtonWorkSpaceClicked(bool)
{
	// ļѡԻѡһ .tif ļ
	QString fileName = QFileDialog::getExistingDirectory(this, u8"ѡռ·", "");

	if (!fileName.isEmpty()) {
		ui->lineEditWorkDir->setText(fileName);
	}
	else {
		QMessageBox::information(this, u8"ûѡļ", u8"ûѡκļ");
	}
}

void QGF3StripBatchProcessDialog::ontstateChanged(int  checked)
{
	bool checkedflag = ui->checkBoxDEM->isChecked();
	if (!checkedflag) {
		ui->pushButton_lineDEM->setEnabled(true);
		ui->lineEdit_DEM->setEnabled(true);
	}
	else {
		ui->pushButton_lineDEM->setEnabled(false);
		ui->lineEdit_DEM->setEnabled(false);
	}
}

void QGF3StripBatchProcessDialog::onpushButtonDEM(bool flag)
{
	QString fileName = QFileDialog::getOpenFileName(this, u8"ѡDEMļ", "", u8"tif (*.tif);;All Files (*)");
	if (!fileName.isEmpty()) {
		ui->lineEdit_DEM->setText(fileName);
	}
	else {
		QMessageBox::information(this, u8"ûѡļ", u8"ûѡκļ");
	}
}

void showQGF3StripBatchProcessDialog(QWidget* parent)
{
	QGF3StripBatchProcessDialog* dialog = new QGF3StripBatchProcessDialog(parent);
	dialog->setWindowTitle(u8"GF3Ӱ");
	dialog->setAttribute(Qt::WA_DeleteOnClose);
	dialog->show();
}

QString getDefaultDEMFilePath()
{
	QString fileName = QFileDialog::getOpenFileName(nullptr, u8"ѡDEMļ", "", u8"tif (*.tif);;All Files (*)");
	return QString();
}



